/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.extractors;

import it.eng.configurazione.bean.ExtractionProcess;
import it.eng.configurazione.service.ConfigurationDAO;
import it.eng.configurazione.service.HibernateUtils;

import org.hibernate.Session;


public class OperationCoordinatorFactory {

	private static Session sessione= null;
	
	public static OperationCoordinatorInterface create(String process){
		
		if (sessione==null) sessione= HibernateUtils.getSession();
		ConfigurationDAO dao=new ConfigurationDAO(sessione);
		ExtractionProcess extractionProcess=dao.readExtractionProcess(process);
		
		// get the coordinator instance
		OperationCoordinatorInterface coordinator=null;
		String coordinatorClass=extractionProcess.getInterfaceInfo().getClassforname();
		try {
			coordinator  = (OperationCoordinatorInterface)Class.forName(coordinatorClass).newInstance();
			coordinator.init(extractionProcess);
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}

		return coordinator;
	}
	
}
